require_relative 'player.rb'

module StudioGame
  class BerserkPlayer < Player
    attr_reader :w00t_count

    def initialize(health, name)
      super(health, name)
      @w00t_count = 0
    end

    def berserk?
      @w00t_count > 5
    end

    def w00t
      puts "Berserker got w00ted!"
      super
      @w00t_count += 1
      puts "Berserker is berserk!" if berserk?
    end

    def blam
      if berserk?
        w00t
      else
        super
      end
    end
  end
end

if __FILE__==$0
  berserker = BerserkPlayer.new("berserker", 50)
   6.times { berserker.w00t }
   2.times { berserker.blam }
   puts berserker.health
end
