require_relative 'playable.rb'

module StudioGame
  class Player
    include Playable
    def initialize(name, health = 100)
      @name = name
      @health = health
      @found_treasures = Hash.new(0)
    end

    attr_accessor :health

    def name=(new_name)
      @name = new_name.capitalize
    end

    attr_accessor :name

    def self.from_csv(string)
      name, health = string.split(',')
      Player.new(name, Integer(health))
    end


    def each_found_treasure
      @found_treasures.each do |name, points|
        yield Treasure.new(name,points)
      end
    end

    def found_treasure(treasure)
      @found_treasures[treasure.name] += treasure.points
      puts "#{@name} found a #{treasure.name} worth #{treasure.points}"
      puts @found_treasures[treasure.name]
    end

    def points
       @found_treasures.values.reduce(0, :+)
    end

    def to_s
      "I am #{@name.capitalize} with health = #{@health}, points = #{points}, and score = #{score}."
    end

    # def w00t
    #   @health += 10
    # end
    #
    # def blam
    #   @health -= 15
    # end

    def score
      @health + points
    end

    # def strong?
    #   @health > 100
    # end

    def <=>(other)
      other.score <=> score
    end
  end
end
